/*
 * ʰץץեѥɥ饤 (single-task only)
 *
 * (C)Copyright 2009, Yashiro Takeshi, Sakamura/Koshizuka Lab.
 */

#define	DEBUG_MODULE "(sysprof)"
#include <tk/tkernel.h>
#include <tk/dbgspt.h>
#include <device/sdrvif.h>
#include <device/util.h>
#include <util/debug.h>

#include "vf.h"


/* From the book "Binary Hacks", Hack #63 */
typedef struct layout {
    struct layout *ebp;
    void* ret;
} layout;


VP get_instruction_pointer(W tid)
{
    ER er;
    T_EIT pk_eit;
    T_CREGS pk_cregs;
    T_TSKSPC pk_tskspc;

    er = tk_get_reg(tid, NULL, &pk_eit, &pk_cregs);
    if (er < 0) {
        return NULL;
    }

    /*
     * ʲϥץˡƥॳΥɥ쥹ǤϤʤ
     * ƥॳθƤӽФΥɥ쥹ɽ褦ˤƤ롣
     * (Τ褦ʽפʤ鳰ȡ)
     */
    if (((W)pk_eit.eip & 0x80000000) != 0) {
        /* CAUTION: ֤ͭ */
        pk_tskspc.uatb = pk_cregs.uatb;
        pk_tskspc.lsid = pk_cregs.lsid;
        tk_set_tsp(TSK_SELF, &pk_tskspc);

        /* T-Kernel/PCATͽ 3.10  */
        if (pk_cregs.usp != NULL) {
            return *(VP*)pk_cregs.usp;
        }
    }
    return pk_eit.eip;
}

